// -*-C++-*-
//
// File:      CommentBuf.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Mar  5 10:37:25 MET 2002

#ifndef CommentBuf_h
#define CommentBuf_h

/* TODO:
     Move this to the backward location of package sas
 */
//----------------------------------------------------------------------------
// BEGIN: non-ANSI stdc++ issues
#ifndef USE_ISO_COMPLIANT_STD
#  define USE_ISO_COMPLIANT_STD 1
#  if defined(__GNUC__) && ( __GNUC__ == 2 )
#    undef USE_ISO_COMPLIANT_STD
#  endif
#endif


// non-ANSI stdc++ issues
#ifdef USE_ISO_COMPLIANT_STD
#  include <streambuf>
#else
#  include <streambuf.h>
   namespace std
   {

     // mimic standard, as GCC-2.95 does not know about these
     class ios_base : public ios
     {
       typedef io_state iostate;
     };
     
   }; // namespace std
#endif
// END: non-ANSI stdc++ issues
//----------------------------------------------------------------------------

#include <string>

class CommentBuf : public std::streambuf
{
public:
  
  // Create a CommentBuf using a specified streambuf
  CommentBuf(std::streambuf* buf);
  ~CommentBuf();
  string line() const; // Return the current line
  unsigned int lineNumber() const; // Return number of the current line


//----------------------------------------------------------------------------
#ifndef USE_ISO_COMPLIANT_STD
  typedef int       int_type;
  typedef streampos pos_type;
  typedef streamoff off_type;
  typedef int       openmode;
  typedef char      char_type;
  
  struct traits_type
  {
  public:
    static char to_char_type(int i) {return char(i);}
    static char eof()               {return EOF;}
  };
  
#endif
//----------------------------------------------------------------------------
protected:
  virtual int_type underflow(); // get area empty

  /* DO NOT OVERWRITE:
     =================
     virtual int_type uflow();
     virtual std::streamsize xsgetn(char_type* c,std::streamsize n);
  */
  /* NOT NEEDED TO OVERWRITE:
     ========================
     virtual std::streamsize showhowmanyc();
     virtual std::streamsize xsputn(const char_type*, std::streamsize __n);
     virtual int_type overflow(int_type =std::traits_type::eof())
   */
  
  virtual int_type pbackfail(int_type =traits_type::eof());

  virtual pos_type seekoff(off_type,
			   std::ios_base::seekdir,
			   std::ios_base::openmode
			   =std::ios_base::in|std::ios_base::out);

  virtual pos_type seekpos(pos_type,
			   std::ios_base::openmode =
			   std::ios_base::in|std::ios_base::out);

  virtual int sync();


public: /*private:*/

  // Enlarge the buffer and return pointer to previous end point.
  // Hence the buffer dynamically resizes to accomodate the longest line.
  char_type* enlargeBuffer();

  void show();
  void findLineInfo(pos_type);

  // Member data
  std::streambuf*   _realbuf;
  char_type*        _buffer;

  unsigned int      _bufferSize;
  unsigned int      _bufferFilled;

  char_type*        _lineBegin;
  int               _lineLength;
  unsigned int      _lineNumber;

  
};

#endif
