/*****************************************************************************
 *
 *  LayoutPrinter.h                             XMM Science Analysis Subsystem
 *
 *  Plug-in printer for testing GUI layout classes
 *
 *  (c) 1998-2000  ESA  -  Written by Jon Brumfitt, Aurora
 *                      -  Exported by Jorgo Bakker, BSC to layout package
 *
 *  $Id: LayoutPrinter.h,v 1.3 2002/08/29 15:16:13 jbakker Exp $
 *
 *****************************************************************************/

#ifndef LAYOUTPRINTER_H
#define LAYOUTPRINTER_H

#include "LayoutBuilder.h"

#include <iostream>
#include <iomanip>

//================================================================
//  Class LayoutPrinter
//================================================================

class LayoutPrinter : public LayoutBuilder
{
public:
    LayoutPrinter(ostream* os, int indent=0) : _os(os), _indent(indent) {}
    void buildSimple(Layout*);
    void buildFrame(Layout*);
    void buildCards(Layout*);
    void buildRow(Layout*);
    void buildColumn(Layout*);
    void buildEnable(Layout*);
    void buildChoice(Layout*);

private:

    ostream* _os;
    int      _indent;
};

#endif
